(*-------------------------------------------------------------------------*)
(*                                                                         *)
(*  Amiga Oberon Interface Module:                    Date: 02-Nov-92      *)
(*                                                                         *)
(*    1992 by Fridtjof Siebert                                            *)
(*                                                                         *)
(*-------------------------------------------------------------------------*)

MODULE MathIEEEDoubTrans;

IMPORT e    := Exec,
       I    := Intuition,
       ml * := MathLibrary,
       sys  := SYSTEM;

CONST

  mathIEEEDoubTransName * = "mathieeedoubtrans.library";

VAR

  base * : ml.MathIEEEBasePtr;

PROCEDURE Atan  * {base,- 30}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Sin   * {base,- 36}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Cos   * {base,- 42}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Tan   * {base,- 48}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Sincos* {base,- 54}(VAR cos{8} : LONGREAL;
                              x{0}       : LONGREAL): LONGREAL;
PROCEDURE Sinh  * {base,- 60}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Cosh  * {base,- 66}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Tanh  * {base,- 72}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Exp   * {base,- 78}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Log   * {base,- 84}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Pow   * {base,- 90}(exp{2}     : LONGREAL;
                              x{0}       : LONGREAL): LONGREAL;
PROCEDURE Sqrt  * {base,- 96}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Tieee * {base,-102}(x{0}       : LONGREAL): e.SINGLE;
PROCEDURE Fieee * {base,-108}(x{0}       : e.SINGLE): LONGREAL;
PROCEDURE Asin  * {base,-114}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Acos  * {base,-120}(x{0}       : LONGREAL): LONGREAL;
PROCEDURE Log10 * {base,-126}(x{0}       : LONGREAL): LONGREAL;


(* $OvflChk- $RangeChk- $StackChk- $NilChk- $ReturnChk- $CaseChk- *)


BEGIN

  base := e.OpenLibrary(mathIEEEDoubTransName,34);
  IF base=NIL THEN
    sys.SETREG(0,I.DisplayAlert(0,"\x00\x64\x14missing mathieeedoubtrans.library\o\o",50));
    HALT(0)
  END;

CLOSE

  IF base#NIL THEN e.CloseLibrary(base) END;

END MathIEEEDoubTrans.


